Option Explicit
Const NOPATH="** No Path **"
Const SCRIPTHOST = "cscript.exe //nologo "
Const FILTERSFOLDER = "Filters"
Dim LastCommand
LastCommand = SCRIPTHOST
Dim fso 'as FileSystemObject
Dim WshShell 'as WshShell

Sub Script_Open(From)
Set WshShell = CreateObject("WScript.Shell")
Dim ExtFilter 'as WshExec
Dim InpBox 'as IInputBox
Dim FiltList 'as IMenu
Dim wsfilt 'as File
Dim Command,UserCommand,Source,Result,ErrStr,prompt,title,LastChar,filtersFolderName,NextCommand
LastChar = ""
Select Case From
  Case 5 'editor
    Select Case Editor.Block.Type
      Case BTYPE_STREAM
      Case BTYPE_NONE
      Case BTYPE_COLUMN
        Far.Msg("Wrong Block type: for STREAM and all text only")
        Exit Sub
      Case Else
    End Select 'block
    'list of wsf-filters
    Set WshShell = CreateObject("WScript.Shell")
    Set fso = CreateObject("Scripting.FileSystemObject")
    filtersFolderName =  Script.Home & FILTERSFOLDER & "\"
    do
      Set FiltList = Far.CreateObject("Menu")
      For Each wsfilt In fso.GetFolder(filtersFolderName).Files
        FiltList.Items.Add(wsfilt.Name)
      Next 'wsfilt
      FiltList.Title="롥 䨫-ਯ"
      FiltList.Bottom="'Esc'-   ,  䨫 'F7'- 㣠   䨫ࠬ"
      FiltList.BreakKeys.Add(VK_F7)
      FiltList.Flags = FMENU_WRAPMODE + FMENU_AUTOHIGHLIGHT
      If FiltList.Show() Then
        If FiltList.BreakCode < 0 Then
          NextCommand = SCRIPTHOST & """" & _
          filtersFolderName & FiltList.Items(FiltList.Selected).Text & """ "
          Exit do
        Else 'F7
          filtersFolderName = GetNewFolder
          If filtersFolderName = "" Then 
            NextCommand = LastCommand: Exit Do
          End If
        End IF
      Else 'ESC
        NextCommand = LastCommand: Exit do
      End If
    loop
    Set InpBox = Far.CreateObject("InputBox")
    prompt= "।  ப  ᪠ 䨫"
    title = "譨 䨫"
    If InpBox.Show(prompt,NextCommand,FIB_BUTTONS+FIB_EXPANDENV,title,"ExtFilter") Then
      UserCommand=InpBox.Text
      LastCommand = UserCommand
      Command="%comspec% /c " & UserCommand
      Set ExtFilter = WshShell.Exec(Command)
      Select Case Editor.Block.Type
        Case BTYPE_STREAM
          Source = GetSelectedString(vbCrLf)
          If Editor.Block.EndPos=0 Then LastChar=vbCrLf
        Case BTYPE_NONE
          Source = GetAllText(vbCrLf)
        Case Else
      End Select 'block
      ExtFilter.StdIn.Write Source: ExtFilter.StdIn.Close()
      Result = ExtFilter.StdOut.ReadAll
      ErrStr = ExtFilter.StdErr.ReadAll
      If ErrStr="" Then
        Far.CopyToClipboard(Replace(Result & LastChar,vbCrLf,vbCr))
        'Insert into text
        Select Case Editor.Block.Type
          Case BTYPE_STREAM
            WshShell.SendKeys("^d")
            WshShell.SendKeys("^v")
          Case BTYPE_NONE
            WshShell.SendKeys("^a")
            WshShell.SendKeys("^d")
            WshShell.SendKeys("^v")
            WshShell.SendKeys("^u")
          Case BTYPE_COLUMN
            Far.Msg("Wrong Block type: for STREAM and all text only")
            Exit Sub
          Case Else
        End Select 'block
      Else
        Far.Msg("Error: " & ErrStr )
        Far.Msg("Out: " & Result)
      End If
    End If
  Case Else
    About
End Select 'From
End Sub

Function GetSelectedString(eolstr)
Dim Selection 'As Editor.Block
Dim SelectedString, SelectedSubString, i
On Error Resume Next
SelectedString = ""
If CLng(Editor.Block.Type) <> CLng(BTYPE_NONE) Then
  Set Selection = Editor.Block
  For i=(Selection.StartLine) To (Selection.EndLine-1)
    SelectedSubString = Mid(Editor.Lines.Item(i), Selection.StartPos(i), _
                                                  Selection.EndPos(i)-Selection.StartPos(i)+1)
    'If SelectedSubString > "" Then 
    SelectedString = SelectedString & SelectedSubString & eolstr
  Next
  SelectedSubString = Mid(Editor.Lines.Item((Selection.EndLine)), Selection.StartPos(Selection.EndLine), _
                                              Selection.EndPos(Selection.EndLine) - _
                                              Selection.StartPos(Selection.EndLine) + 1)
  SelectedString = SelectedString & SelectedSubString
End If 'Block
On Error GoTo 0
GetSelectedString = SelectedString
End Function

Function GetAllText(eolstr)
Dim SelectedString,i
For i=1 to Editor.Lines.Count-1
  SelectedString = SelectedString & Editor.Lines(i) & eolstr
Next
SelectedString = SelectedString & Editor.Lines(Editor.Lines.Count)
GetAllText = SelectedString
End Function

Sub About()
dim DP 'as IMessage
Set DP=Far.CreateObject("Message")
DP.Header = "Help for you ============ (c)DkmS 2001"
DP.Body.Add("Apply External Filter in FAR editor")
DP.Body.Add("----")
DP.Body.Add("Developed by Konstantin Dyakov, dyakovkm@paris.com")
DP.Body.Add("Idea of Michael Yutsis, michael.y@bigfoot.com")
DP.Body.Add("Requirements:")
DP.Body.Add("Plugin ScriptHost by V.Pechenin, slava@baltica.ru")
DP.Body.Add("----")
DP.Body.Add("License - FreeWare")
DP.Body.Add("$$$$")
DP.Body.Add("Software is confidential")
DP.Body.Add("and copyrighted.")
'DP.Body.Add(" ")
DP.Show
End Sub

Function GetNewFolder()
dim NewFolder
  NewFolder = GetFolderName("Choose Folder where yours filters lives")
  If NewFolder=NOPATH Then
    GetNewFolder = ""
  Else
    GetNewFolder = NewFolder
  End If
End Function

Function GetFolderName(brTitle)
Dim sh, fol, s, fils, fil, i, sn, s1, sp, fpar, spath, col, pt, pt1
Set sh = CreateObject("Shell.Application")
set fol = sh.browseforfolder(clng(0), brTitle, clng(0))
on error resume next
sn = fol.title
if err.number <> 0 then  '--cancel was clicked.
    sn=NOPATH
else
  set fil = fol.items.item(0)
  s1=fil.path
  spath = left(s1, len(s1) - (len(fil.name) + 1))
  if spath <> "" then
    If fso.FolderExists(spath) Then
      sn=fso.GetAbsolutePathName(spath)
    Else
      sn=NOPATH
    End If 'fso
  else
    sp = "a"
    Do while sp <> ""
      on error resume next
      Set fpar = fol.parentfolder
      sp = fpar.title
      if err.number <> 0 then
         If fso.FolderExists(sn) Then
          sn=fso.GetAbsolutePathName(sn)
         Else
            pt1 = instrrev(sn, ":")
            if pt1 = 0 then
              sn=NOPATH
            else
              sn =  mid(sn, pt1 - 1, 2) & "\"
            end if
         End If 'fso
         exit do
      end if
      err.clear
      Set fol = fpar
      If sp <> "" then
        col = instrrev(sp, ":")
        if col = 0 then
          sn = sp & "\" & sn
        else
          sn = mid(sp, col - 1, 2) & "\" & sn
          exit do
        end if
      end if
    loop
  end if
end if
set fils = nothing
set fpar = nothing
set fol = nothing
set sh = nothing
'set fso = nothing
GetFolderName = sn
End Function
